// Main header script - this will be included into every script in
// the game (local and global). Do not place functions here; rather,
// place import definitions and #define names here to be used by all
// scripts.

// --- values for globalint ---
#define NO_CHAR -1

// --- character functions ---
// import function IsKidAlive (int charid);
import function IsKidHereAndAlive (int charid);
import function FirstKidAlive ();
// import function NearestKid (int charid);
import function PlayerDies ();
import function IsTrainedGI (int charid);
import function IsTrained (int charid);

// --- cutscene functions ---
import function BeginCutscene (int actor);
import function FinishCutscene (int CutsceneEnded);
import function IsCutscene ();
import function ToDungeon (int charid);
import function SendEdBackIntoHisRoom ();
import function SendEdnaBackIntoHerRoom ();
import function FinalScene ();

// --- owntimer ---
import function SetOwnTimer (int timerid, int timeout);
import function IsOwnTimerExpired (int timerid);

// --- Speech ---
import function DisplaySpeechBackgroundEx (int charid, string message);
import function repeatedly_execute_always ();

// --- action ---
#define A_SWITCH_TO -2
#define A_DEFAULT   -1
#define A_WALK_TO    0
#define A_LOOK_AT    1
#define A_TALK_TO    2
#define A_GIVE_TO    3
#define A_PICK_UP    4
#define A_USE        5
#define A_OPEN       6
#define A_CLOSE      7
#define A_PUSH       8
#define A_PULL       9
#define A_COUNT_    10
#define A_USE_INV   -3

import function UsedAction (int test_action);

// --- cancelable semi-blocking move-player-character functions:---
import function MovePlayer (int x, int y);
import function GoToCharacter (int charid, int direction, int NPCfacesplayer, int blocking);
import function NPCGoToCharacter (int charidwhogoes, int charidtogoto, int direction, int NPCfacesplayer, int blocking);

// -- interaction function ---
import function Unhandled ();

// --- parameters for CallRoomScript / on_call ---
#define CRS_DUMMY          0
#define HUNTER_GOT_IT      1
#define GAME_RESTORED      2
#define ED_ON_WAY_UP       3
#define EDNA_ENTERS_ROOM   4
#define ED_ON_WAY_DOWN     5
#define ED_ENTERS_ROOM_19  6

// --- translation ---
import function TranslateNumber (string number_name);
import function getInteger (string numbers);

// --- sound functions ---
import function AlarmSound ();
  
// --- FaceDirection ---
#define DIR_UP    2
#define DIR_LEFT -1
#define DIR_DOWN  0
#define DIR_RIGHT 1

import function FaceDirection (int CharId, int dir);

// --- interaction functions ---
import function PlaceCharacter (int charid, int x, int y, int dir);
import function PlacePC (int x, int y, int dir);
import function init_object (int GI, int object);

import function any_click_move (int x, int y, int dir);
import function any_click_walk (int x, int y, int dir);
import function any_click_walk_look (int x, int y, int dir, string lookat);
import function any_click_on_door (int GI, int object, int x, int y, int dir, int nr_room, int nr_x, int nr_y, int nr_dir);
import function SetDoorStrings (const string lookat,const string islocked,const string wrongitem);
import function any_click_on_door_special (int GI, int object, int x, int y, int dir, int nr_room, int nr_x, int nr_y, int nr_dir, int opensound, int closesound, int key, int closevalue);
import function any_click_on_light_switch (int hotspot, int x, int y, int dir);
import function any_click_use_inv (int item, int x, int y, int dir);
import function any_click_walk_look_pick (int x, int y, int dir, string lookat, int object, int item, int GI, int sound);

import function SetWalkTo (int x, int y, int dir);
import function MovedTo ();
import function WalkedToLookedAt (string lookat);
import function UsedInvItem (int item);
import function WalkedToLookedAtPickedUp (string lookat, int object, int item, int GI, int sound);  
import function EnterRoom (int room, int x, int y, int dir);

// --- hunting ---
import function StartHunting (int hunter);
import function StopHunting ();

// --- digit key pad functions ---
import function KeyPad (int room_cancel, int room_wrong, int number1, int room_ok1, int number2, int room_ok2);

// --- DisplaySpeechbackground functions ---
import function qDisplaySpeech(int CharID, string message);
import function qStopSpeech();
import function qIsTalking();
import string   Delay(int time);
import function qSkipCurrentMessage();
  
// --- cutscene id for room enter ---
#define NO_CUTSCENE           0
#define ED_IS_HUNGRY          1
#define ED_HEARS_DOORBELL     2
#define ED_AND_FRED_HAMSTER   3
#define ED_ORDERS_PLANS       4
#define ED_IN_KITCHEN         5
#define ED_AT_FRONT_DOOR      6
#define ED_CAPTURES_KID       7
#define SANDY_CRIES_FOR_HELP  8
#define EDNA_ANSWERS_PHONE    9
#define ED_TALKS_TO_EDNA     10
#define FRED_TALKS_TO_EDNA   11
#define KID_DIES_IN_POOL     12
#define KIDS_DIE_IN_POOL     13
#define BACK_FROM_HIGHSCORE  14
#define FRED_PLAYS_GAME      15
#define CALL_FINISHED        16
#define FINAL_SCENE          17
#define POOL_IS_EMPTY        18
#define MACHINE_IS_READY     19
#define POWER_OFF_FIRST_TIME 20
#define POWER_OFF_AGAIN      21
#define INTRO                22
#define OUTRO_EXPLOSION      23
#define NORMAL_ENTER_ROOM    24
#define KEY_PAD_CANCEL       25
#define KEY_PAD_WRONG        26
#define KEY_PAD_OK_1         27
#define KEY_PAD_OK_2         28
#define OUTRO_ALLKIDSDEAD    29
// Automatically converted interaction variables
import int IntVar_Global_1;
